<!DOCTYPE html>
<html>
    <head>

    </head>
    <body>
        <input type="button" value="alert" onclick="alert('onclick event')">
        <input type="button" value="function" onclick="display()">
        <input id="oc" type='button' value="dom">
        <button id="btn" onclick="display2(this.innerHTML)">BUTTON</button>
        <input  id="event" type="button" value="event">
        <script>
            function display()
            {
                alert('onclick in function')
            }
            let oc1=document.getElementById('oc')
            oc1.onclick=display1  //don't assign display1()
            function display1()
            {
                alert('onclick in script dom')
            }
            //above 16to 20 lines can also be written as follows
            // oc.onclick=function()
            // {
            //     alert('onclick in script dom')
            // }
            function display2(msg)
            {
                alert(msg)
            }
            let event=document.getElementById('event')
            event.addEventListener("click", handler1);
            function handler1()
            {
                alert("click in addEventListener")
            }
            //DOMContentLoaded works only with addEventListener
            console.log(document.readyState)
            document.addEventListener("DOMContentLoaded", function() {alert("DOM built");});
            window.addEventListener("load",function() {alert("DOM load");})
            document.addEventListener("beforeunload",function() {return "";})
            document.addEventListener('unload',function() {return "vgh"})
            document.addEventListener('readystatechange', () => console.log(document.readyState));
        </script>
    </body>
</html>